package com.jiuqi.util;

import java.lang.reflect.Method;
import java.util.BitSet;
import java.util.ArrayList;
import java.util.List;

public class BitMatrix
{
    private List bits;
    
    public BitMatrix() {
        this.bits = new ArrayList();
    }
    
    public void clear() {
        for (int i = 0; i < this.bits.size(); ++i) {
            this.bits.set(i, null);
        }
    }
    
    public boolean get(final int x, final int y) {
        final BitSet bs = (y < this.bits.size()) ? this.bits.get(y) : null;
        return bs != null && x < bs.size() && bs.get(x);
    }
    
    public void set(final int x, final int y, final boolean value) {
        while (this.bits.size() <= y) {
            this.bits.add(null);
        }
        BitSet bs = this.bits.get(y);
        if (bs == null) {
            if (!value) {
                return;
            }
            bs = new BitSet();
            this.bits.set(y, bs);
        }
        if (value) {
            bs.set(x);
        }
        else {
            bs.clear(x);
        }
    }
    
    public boolean hasTrue(final int y) {
        if (y >= this.bits.size()) {
            return false;
        }
        final BitSet bs = this.bits.get(y);
        if (bs == null) {
            return false;
        }
        Method nextSetBit = null;
        try {
            final Class[] parameterTypes = { Integer.TYPE };
            nextSetBit = bs.getClass().getMethod("nextSetBit", (Class<?>[])parameterTypes);
            if (nextSetBit != null) {
                final Object[] parameters = { new Integer(0) };
                return (int)nextSetBit.invoke(bs, parameters) >= 0;
            }
        }
        catch (final Exception ex) {
            ex.printStackTrace();
        }
        for (int i = 0; i < bs.size(); ++i) {
            if (bs.get(i)) {
                return false;
            }
        }
        return true;
    }
    
    public static void main(final String[] args) {
        final BitMatrix bm = new BitMatrix();
        bm.set(100, 1, true);
        System.out.println(bm.hasTrue(0));
        System.out.println(bm.hasTrue(1));
    }
}
